#include "stdafx.h"
#include "bindep.h"
#include <windows.h>
#include <stdio.h>
#include <malloc.h>

#define STAR_DOT_STAR "*.*"

#define DUMPBINCMDLINE "dumpbin /IMPORTS /OUT:"


#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

static int internal_main(int argc, char* argv[]);


CWinApp theApp;

using namespace std;


#define DELAY_LOAD_START "  Section contains the following delay load imports:"

BOOL WriteFileDependencies(FILE *fpDot, LPCSTR szFileName, LPCSTR szTmpFile, const CStringList *pslExcludeFiles)
{
  PROCESS_INFORMATION pi;
  STARTUPINFO si;
  ZeroMemory(&si, sizeof(STARTUPINFO));
  si.cb = sizeof(STARTUPINFO);
  si.dwFlags = STARTF_USESHOWWINDOW;
  si.wShowWindow = SW_HIDE;
  size_t stTmpLen = strlen(szTmpFile);
  size_t stFileLen = strlen(szFileName);
  BOOL bSuccess = TRUE;

  LPSTR szCmdLine = (LPSTR) _alloca(sizeof(DUMPBINCMDLINE) + stTmpLen + stFileLen + 1);
  memcpy(szCmdLine, DUMPBINCMDLINE, sizeof(DUMPBINCMDLINE));
  memcpy(&szCmdLine[sizeof(DUMPBINCMDLINE)-1], szTmpFile, stTmpLen);
  szCmdLine[sizeof(DUMPBINCMDLINE)+stTmpLen-1] = ' ';
  memcpy(&szCmdLine[sizeof(DUMPBINCMDLINE)+stTmpLen], szFileName, stFileLen+1);

  if(!CreateProcess(NULL, szCmdLine, NULL, NULL, FALSE, NORMAL_PRIORITY_CLASS|CREATE_NEW_CONSOLE, NULL,
    NULL, &si, &pi))
  {
    printf("Failed to start command line %s with %lu\n", szCmdLine, GetLastError());
    return FALSE;
  }

  WaitForSingleObject(pi.hProcess, INFINITE);
  DWORD dwExitCode = 0L;
  bSuccess = GetExitCodeProcess(pi.hProcess, &dwExitCode);
  DWORD dwLastErr = GetLastError();
  CloseHandle(pi.hProcess);
  CloseHandle(pi.hThread);
  
  if (!bSuccess)
  {
    printf("Failed to get process exit code with %lu\n", dwExitCode);
    return FALSE;
  }

  /// 
  /// okay now we have the output of dumpbin in file szTmpFile
  /// 

  TRY
  {
    CStdioFile fRead(szTmpFile, CFile::modeRead);
    CString strLine;    
    LPCTSTR szFile = strrchr(szFileName, '\\');
    szFile = &szFile[1];
    CString strFile(szFile);
    strFile.MakeLower();
    BOOL bDelayLoaded = FALSE;

    if(pslExcludeFiles->Find(strFile))
      return TRUE;

    if (0>fprintf(fpDot, "\n  \"%s\"\n", strFile))
    {
      printf("Failed to write into dot file\n");
      return FALSE;
    }

    while (fRead.ReadString(strLine))
    {
      if (!strcmp(strLine, DELAY_LOAD_START))
        bDelayLoaded = TRUE;

      int iLen = strLine.GetLength();
      if (iLen>4 && !strncmp(strLine, "    ", 4) && strLine.GetAt(4)!=' ' && strLine.Mid(4).Find("Bound to ")!=0 )
      {
        strLine = strLine.Mid(4);
        strLine.MakeLower();
        if (!pslExcludeFiles->Find(strLine) && 0>fprintf(fpDot, "  \"%s\" -> \"%s\" %s\n", strFile, strLine, bDelayLoaded?_T(" [color = \"gainsboro\"]"):_T("")))
        {
          printf("Failed to write into dot file\n");
          return FALSE;
        }
      }



    }
  }
  CATCH(CFileException , exc)
  {


  }
  CATCH(CMemoryException , exc)
  {


  }
  END_CATCH

  

  return TRUE;
}










BOOL WriteDependencies(FILE *fpDot, LPCSTR srcdir, int iArgc, char **lpszArgv, 
  BOOL bRecursive, LPCSTR szTmpFile, const CStringList *pslExcludeFiles, const CStringList *pslExcludeSrcDirs)
{
  BOOL bRet = TRUE;
  
  if (bRecursive)
  {
    WIN32_FIND_DATA wfd;
    ZeroMemory(&wfd, sizeof(WIN32_FIND_DATA));
    size_t stLen1 = strlen(srcdir);
    size_t stLen2 = sizeof(STAR_DOT_STAR);
    LPSTR szWildCardPattern = (LPSTR)malloc( (stLen1+stLen2+1)*sizeof(char));
    if (!szWildCardPattern)
    {
      printf("Not 'nuff memory\n");
      return FALSE;
    }

    memcpy(szWildCardPattern, srcdir, stLen1*sizeof(char));
    szWildCardPattern[stLen1] = '\\';
    memcpy(&szWildCardPattern[stLen1+1], STAR_DOT_STAR, stLen2*sizeof(char));

    HANDLE hFind = FindFirstFile(szWildCardPattern, &wfd);

    if (INVALID_HANDLE_VALUE != hFind)
    {
      do 
      {
        if (strcmp(wfd.cFileName, ".") && strcmp(wfd.cFileName, "..") && 
          (wfd.dwFileAttributes&FILE_ATTRIBUTE_DIRECTORY) )
        {
          size_t stLen3 = 1 + strlen(wfd.cFileName);
          LPSTR szFileName = (LPSTR)malloc((stLen1 + stLen3 + 1)*sizeof(char));
          if(szFileName)
          {
            memcpy(szFileName, srcdir, stLen1*sizeof(char));
            szFileName[stLen1] = '\\';
            memcpy(&szFileName[stLen1+1], wfd.cFileName, (stLen3)*sizeof(char));
            // printf("%s\n", szFileName);
            bRet = WriteDependencies(fpDot, szFileName, iArgc, lpszArgv, TRUE, szTmpFile, 
              pslExcludeFiles, pslExcludeSrcDirs);
            free(szFileName);
          }
          else
            bRet = FALSE;
        }
      }
      while (bRet && FindNextFile(hFind, &wfd));
    }
    else
    {
      printf("Warning: Failed to get files for %s with %lu\n", szWildCardPattern, GetLastError());
    }

    free(szWildCardPattern);
  }
  
  /// test if we are in a pslExcludeSrcDirs directory:
  CString strDir = srcdir;
  strDir.MakeLower();

  if (pslExcludeSrcDirs->Find(strDir))
    return TRUE;
  
  for (int i= 0;i<iArgc;i++)
  {
    WIN32_FIND_DATA wfd;
    ZeroMemory(&wfd, sizeof(WIN32_FIND_DATA));
    size_t stLen1 = strlen(srcdir);
    size_t stLen2 = 1 + strlen(lpszArgv[i]);

    LPSTR szWildCardPattern = (LPSTR)malloc( (stLen1+stLen2+1)*sizeof(char));
    if (!szWildCardPattern)
    {
      printf("Not 'nuff memory\n");
      return FALSE;
    }

    memcpy(szWildCardPattern, srcdir, stLen1*sizeof(char));
    szWildCardPattern[stLen1] = '\\';
    memcpy(&szWildCardPattern[stLen1+1], lpszArgv[i], stLen2*sizeof(char));

    
    HANDLE hFind = FindFirstFile(szWildCardPattern, &wfd);

    if (INVALID_HANDLE_VALUE != hFind)
    {
      do 
      {
        if (strcmp(wfd.cFileName, ".") && strcmp(wfd.cFileName, "..") && 
          !(wfd.dwFileAttributes&FILE_ATTRIBUTE_DIRECTORY) )
        {
          size_t stLen3 = 1 + strlen(wfd.cFileName);
          LPSTR szFileName = (LPSTR)malloc((stLen1 + stLen3 + 1)*sizeof(char));
          if(szFileName)
          {
            memcpy(szFileName, srcdir, stLen1*sizeof(char));
            szFileName[stLen1] = '\\';
            memcpy(&szFileName[stLen1+1], wfd.cFileName, (stLen3)*sizeof(char));
            // printf("%s\n", szFileName);
            bRet = WriteFileDependencies(fpDot, szFileName, szTmpFile, pslExcludeFiles);

            free(szFileName);
          }
          else
            bRet = FALSE;
        }
      }
      while (bRet && FindNextFile(hFind, &wfd));
    }
    else
    {
      printf("Warning: Failed to get files for %s with %lu\n", szWildCardPattern, GetLastError());
    }
    free(szWildCardPattern);
  }
  return bRet;
}










int _tmain(int argc, TCHAR* argv[], TCHAR* /*envp*/[])
{
	int nRetCode = 0;

	if (!AfxWinInit(::GetModuleHandle(NULL), NULL, ::GetCommandLine(), 0))
	{
		cerr << _T("Fatal Error: MFC initialization failed") << endl;
		nRetCode = 1;
	}
	else
    nRetCode = internal_main(argc, argv);

	return nRetCode;
}




BOOL FillExcludeList(CStringList &slExcludeFiles, LPCSTR szFileName)
{
  char szModule[_MAX_PATH], szDrv[_MAX_DRIVE], szDir[_MAX_DIR];
  GetModuleFileName(NULL, szModule, _MAX_PATH);
  _splitpath(szModule, szDrv, szDir, NULL, NULL);
  _makepath(szModule, szDrv, szDir, szFileName, "txt");
  BOOL bRet = TRUE;

  CStdioFile excfile;
  if (excfile.Open(szModule, CFile::modeRead))
  {
    
    TRY
    {
      CString strLine;
      while (excfile.ReadString(strLine))
      {
        strLine.MakeLower();
        if (strLine.GetLength())
          slExcludeFiles.AddTail(strLine);
      }
    }
    CATCH(CFileException, exc)
    {
      bRet = FALSE;
    }
    CATCH(CMemoryException, exc)
    {
      bRet = FALSE;
    }
    END_CATCH
  }

  return bRet;
}



int internal_main(int argc, char* argv[])
{
  if (argc<4)
  {
    printf("Usage:\n\nbindep srcdir targetdotfile [/r] wildcardpatterns\n");
    return 1;
  }

  LPCSTR szDotFile = argv[2];
  LPCSTR srcdir = argv[1];
  BOOL bRecursive = argv[3][0]=='/' && (argv[3][1]=='r' || argv[3][1]=='R');
  char **lpszArgv = &argv[bRecursive?4:3];
  int iArgs = argc-(bRecursive?4:3);

  CStringList slExcludeFiles, slExcludeSrcDirs;

  if (!FillExcludeList(slExcludeFiles, "excfile"))
  {
    printf("An error occurred while retrieving the exclude list\n");
    return 1;
  }

  if (!FillExcludeList(slExcludeSrcDirs, "excdirs"))
  {
    printf("An error occurred while retrieving the exclude list\n");
    return 1;
  }

  

  char cSomeDummy;  
  
  DWORD dwTempPathLen = GetTempPath(0L, &cSomeDummy);

  if(!dwTempPathLen)
  {
    printf("Failed to get temp path %lu\n", GetLastError());
    return 1;
  }
  dwTempPathLen++;
  


  LPSTR szTmpPath = (LPSTR)_alloca((dwTempPathLen)*sizeof(char));

  dwTempPathLen = GetTempPath(dwTempPathLen, szTmpPath);

  if(!dwTempPathLen)
  {
    printf("Failed to get temp path 2nd time %lu\n", GetLastError());
    return 1;
  }



  FILE *fpDot = fopen(szDotFile, "wt");
  if (!fpDot)
  {
    printf("Failed to open/create dot file %s\n", szDotFile);
    return 1;
  }

  char szTmpFileName[_MAX_PATH];

  if (!GetTempFileName(szTmpPath, "bdp", 0, szTmpFileName))
  {
    printf("Failed to get temp filename time %lu\n", GetLastError());
    szTmpFileName[0] = '\0';
    goto ERROR_DELETE_FILE;
  }

  if (0>fprintf(fpDot, "digraph G {\n"))
  {
    printf("Failed to write to dot file\n");
    goto ERROR_DELETE_FILE;
  }


  /// now we write the dot file recursively:
  

  if (!WriteDependencies(fpDot, srcdir, iArgs, lpszArgv, bRecursive, szTmpFileName, &slExcludeFiles, &slExcludeSrcDirs))
  {
    printf("Failed to write to dot file\n");
    goto ERROR_DELETE_FILE;
  }

  



  if (0>fprintf(fpDot, "}"))
  {
    printf("Failed to write to dot file\n");
    goto ERROR_DELETE_FILE;
  }



  fclose(fpDot);
  if (szTmpFileName[0])
    unlink(szTmpFileName);  
  return 0;

ERROR_DELETE_FILE:
  fclose(fpDot);
  unlink(szDotFile);  

  if (szTmpFileName[0])
    unlink(szTmpFileName);  

	return 1;
}
